function[P,obj]=Spanno3(Qall,Yall,kList,id_expert)

% Function execute Spanogram algortihm for nd=3 for  
% input : Qall = diag(Y) *K* diag(Y)   matrix of all data point 
%	  Yall = Annotation for all data points 
%	  kList = List of numbers corresponing to noisy labels in positive class and negative class 
%	  id_expert = List of index indicating datapoints annotated by experts
% output: P: probability of chance of being wrongly annotated
%         obj: objective value of optimization problem.  
    
% this function is for only nd =3
nd =3;



N=length(Yall);

%  modified data matrix considering by combining all expert points in the last row. 
non_expert=setdiff([1:1:length(Yall)],id_expert); % index corresponding to all non expert training data
Q=[ Qall(non_expert,non_expert), sum(Qall(id_expert,non_expert),1)'; sum(Qall(id_expert,non_expert),1),sum(sum(Qall(id_expert,id_expert)))   ]; %
Q=0.5*(Q+Q');


Mk=max(kList,[],1)
Y=[Yall(non_expert);0];
[E,D]=eigs(Q,nd,'la');
V=E.*repmat(diag(sqrt(D))',[length(Y),1]);
clear E D Qall
idP=find(Y==1);
idN=find(Y==-1);
obj=-1.00e+20*ones(size(kList,1),1);
P=ones(N,size(kList,1));

clear Yall;

sV=sqrt(sum(V.^2,2));
[AmpV,IDAmpV]=sort(sV,'descend');

for k=1:1:size(kList,1) % For each noise ration
Feta(k).id=[];
eta(k).id=[];
end
minP=AmpV(4) ;

count=ones(size(kList,1),1);
Chk=1;
for i=3:1:length(AmpV)
     disp(i);
     if i > sum(Mk) 
      if AmpV(i) <  minP
         return;
     end
     end
     if i>  50
      if Chk==0
         return;
     else
     Chk=0;
      end
     end
     for j=2:1:i-1
         for j3=1:1:j-1
iSelect=[IDAmpV(i),IDAmpV(j),IDAmpV(j3)]';
temp=V(iSelect,:)-V(iSelect([2,3,1]),:);
c=null(temp);
cV=V*c;
clear temp;
[~,tempP]=sort(cV(idP),'descend');
[~,tempN]=sort(cV(idN),'descend');
temp_warning=warning('off','all');
idp=idP(tempP(1:Mk(1)));
idn=idN(tempN(1:Mk(2)));
warning(temp_warning);
for PosNeg=1:1:2
    if PosNeg==2
        tempP=tempP(length(tempP):-1:1);
        tempN=tempN(length(tempN):-1:1);
    end
for k=1:1:size(kList,1)
   temp_warning=warning('off','all');
   id=[idp(1:kList(k,1));idn(1:kList(k,2)) ];
   warning(temp_warning);
   eta(k).id=[eta(k).id,id];
   count(k)=count(k)+1;

if k==size(kList,1)
if length(find(id==iSelect(1)))>0 | length(find(id==iSelect(2)))>0 | length(find(id==iSelect(3)))>0
if minP>abs(cV(iSelect(1)))
    minP=abs(cV(iSelect(1)))
end
end
end

if sum(Y(iSelect))>1 & kList(k,1)>0
temp= length(find(idp(1:kList(k,1))==iSelect(1)))  + length(find(idp(1:kList(k,1))==iSelect(2)))+ length(find(idp(1:kList(k,1))==iSelect(3))) ;
if temp==1
if length(find(id==iSelect(1)))>0 
    if Y(iSelect(2)) ~= 0 
	idt =[setdiff(id,iSelect(1));iSelect(2)];
	eta(k).id=[eta(k).id,idt];
	count(k)=count(k)+1;
   end
      if Y(iSelect(3)) ~= 0

idt =[setdiff(id,iSelect(1));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
elseif length(find(id==iSelect(2)))>0
if Y(iSelect(1)) ~= 0
    idt =[setdiff(id,iSelect(2));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
if Y(iSelect(3)) ~= 0
idt =[setdiff(id,iSelect(2));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
else
if Y(iSelect(1)) ~= 0
idt =[setdiff(id,iSelect(3));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
if Y(iSelect(2)) ~= 0
idt =[setdiff(id,iSelect(3));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
end
elseif temp ==2
if length(find(id==iSelect(1)))>0 & length(find(id==iSelect(2)))>0
if Y(iSelect(3)) ~= 0    
idt =[setdiff(id,iSelect(1));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;

idt =[setdiff(id,iSelect(2));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
elseif length(find(id==iSelect(2)))>0 & length(find(id==iSelect(3)))>0
if Y(iSelect(1)) ~= 0
    idt =[setdiff(id,iSelect(2));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
idt =[setdiff(id,iSelect(3));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
else
if Y(iSelect(3)) ~= 0
idt =[setdiff(id,iSelect(1));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
idt =[setdiff(id,iSelect(3));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
end
 
end

elseif sum(Y(iSelect))<-1 & kList(k,2)>0
   temp_warning=warning('off','all');
temp= length(find(idn(1:kList(k,2))==iSelect(1)))  + length(find(idn(1:kList(k,2))==iSelect(2))) + length(find(idn(1:kList(k,2))==iSelect(3)));
warning(temp_warning);
if temp==1
if length(find(id==iSelect(1)))>0
if Y(iSelect(2)) ~= 0
    idt =[setdiff(id,iSelect(1));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
if Y(iSelect(3)) ~= 0
idt =[setdiff(id,iSelect(1));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
elseif length(find(id==iSelect(2)))>0
if Y(iSelect(1)) ~= 0
    idt =[setdiff(id,iSelect(2));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
if Y(iSelect(3)) ~= 0
idt =[setdiff(id,iSelect(2));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
else
if Y(iSelect(1)) ~= 0
idt =[setdiff(id,iSelect(3));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
if Y(iSelect(2)) ~= 0
idt =[setdiff(id,iSelect(3));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
end
elseif temp ==2
if length(find(id==iSelect(1)))>0 & length(find(id==iSelect(2)))>0
if Y(iSelect(3)) ~= 0
idt =[setdiff(id,iSelect(1));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
idt =[setdiff(id,iSelect(2));iSelect(3)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
elseif length(find(id==iSelect(2)))>0 & length(find(id==iSelect(3)))>0
if Y(iSelect(1)) ~= 0
    idt =[setdiff(id,iSelect(2));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
idt =[setdiff(id,iSelect(3));iSelect(1)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
else
if Y(iSelect(2)) ~= 0
idt =[setdiff(id,iSelect(1));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
idt =[setdiff(id,iSelect(3));iSelect(2)];
eta(k).id=[eta(k).id,idt];
count(k)=count(k)+1;
end
end

end %end og temp

end %end of  Y(iSelect)

end %for k

end % for Pos


if max(count)>250
	for k=1:1:size(kList,1)
		A=sort(eta(k).id',2);
		eta(k).id=[];
		count(k)=1;
		temp=find(ismem(A,Feta(k).id')==0); 
		if length(temp)>0
			Feta(k).id=[Feta(k).id,A(temp,:)'];

			tempe=ones(N,length(temp));
			tempe2=ones(length(Y),length(temp));

			for t=1:1:length(temp)
				tempid = A(temp(t),:)'; 
                                tempe(non_expert(tempid),t)=-1;
				tempe2(tempid,t)=-1;
			end
			objtemp=sum(tempe2.*(Q*tempe2))';
			[objcur,indexcur]=max(objtemp);
			clear objtemp;
			if obj(k)<objcur
		    		obj(k)=objcur;
    				P(:,k)=tempe(:,indexcur);
				Chk=1;
			end
		end
	end
end


end

end
end
 for k=1:1:size(kList,1)
                A=[];
                A=sort(eta(k).id',2);
                eta(k).id=[];
                count(k)=1;
                temp=find(ismem(A,Feta(k).id')==0)
                
                if length(temp)>0
                        Chk=1;
                        Feta(k).id=[Feta(k).id,A(temp,:)'];

                        tempe=ones(N,length(temp));
                        tempe2=ones(length(Y),length(temp));

                        for t=1:1:length(temp)
				
                                tempid = A(temp(t),:)';
                                tempe(non_expert(tempid),t)=-1;
                                tempe2(tempid,t)=-1;
                        end
                        objtemp=sum(tempe2.*(Q*tempe2))';
                        [objcur,indexcur]=max(objtemp);
                        clear objtemp;
                        if obj(k)<objcur
                                obj(k)=objcur;
                                P(:,k)=tempe(:,indexcur);
                        end
                end
        end
        disp(max(obj));

clear eta V;
return;
end



